{$G+,N+}                                                { 286+, 287+ }
{$R-,S-}

{$DEFINE ZBUFFER}

Unit ZBuffer;

Interface

{$I CONSTS.PAS}

Type
  PZBuf50 = ^TZBuf50;
  TZBuf50 = Array[0..49,0..319] of LongInt;

Const
  PZBuf : Array[0..3] of PZBuf50 = (Nil, Nil, Nil, Nil);

Function Allocate_ZBuffer : Boolean;
Procedure DeAllocate_ZBuffer;
Procedure Clear_ZBuffer;

Implementation

Function Allocate_ZBuffer : Boolean;
Var
  I : Byte;
  Res : Boolean;
Begin
  Res := True;
{$IFDEF ZBUFFER}
  For I := 0 to 3 do
    If MaxAvail >= SizeOf(TZBuf50) then GetMem (PZBuf[I], SizeOf(TZBuf50))
    Else Begin
      Res := False;
      Break
    End;
{$ENDIF}
  Allocate_ZBuffer := Res
End;

Procedure DeAllocate_ZBuffer;
Var
  I : Byte;
Begin
{$IFDEF ZBUFFER}
  For I := 0 to 3 do Begin
    If PZBuf[I] <> Nil then FreeMem (PZBuf[I], SizeOf(TZBuf50));
    PZBuf[I] := Nil
  End
{$ENDIF}
End;

Procedure Clear_ZBuffer;
Var
  I : Word;
Begin
{$IFDEF ZBUFFER}
  For I := 0 to 3 do
    FillChar (PZBuf[I]^, SizeOf(TZBuf50), 0)
{$ENDIF}
End;

End.
